/*
 * ʽBSTʵֵĴʵṹ
 * BinTree
 */

package dsa;

public class BSTree extends BinTree_LinkedList implements Dictionary {
/**************************** ʵ ****************************/
	protected Comparator C;//Ƚ
	protected BinTreePosition lastV;//Ľڵ㣬ԱAVLչƽ

/**************************** 췽 ****************************/
	public BSTree()
	{ this(null, new ComparatorDefault()); }

	public BSTree(BinTreePosition r)
	{ this(r, new ComparatorDefault()); }

	public BSTree(BinTreePosition r, Comparator c)
	{	root = r;	C = c; }

/**************************** ʵ䷽ ****************************/
//ʵдkeyΪؼĿ򷵻еһĿ򣬷null
	public Entry find(Object key) {
		if (isEmpty())	return null;
		BSTreeNode u = binSearch((BSTreeNode)root, key, C);
		return (0 == C.compare(key, u.getKey())) ? (Entry)u.getElem() : null;
	}

//ɹؼΪkeyĿɵĵ
	public Iterator findAll(Object key) {
		List s = new List_DLNode();
		finAllNodes((BSTreeNode)root, key, s, C);
		return s.elements();
	}

//Ŀ(key, value)ظĿ
//lastVָʾĽڵ
	public Entry insert(Object key, Object value) {
		Entry e = new EntryDefault(key, value);//µԪ

		if (isEmpty()) {//ڵ
			lastV = root = new BSTreeNode(e, null, true, null, null);//½ڵ
		} else {//һڵ
			BSTreeNode p = (BSTreeNode)root;//Ӹڵ㿪ʼҿɲλ
			boolean asLeftChild;//ʾ½ڵǷΪpӲ
			while(true) {//ϵ
				p = binSearch(p, key, C);//ҹؼΪkeyĽڵ㣬ֱ
				if (C.compare(key, p.getKey()) < 0)//ʧӽڵ㣬
					{ asLeftChild = true; break; }
				else if (C.compare(key, p.getKey()) > 0)//ʧҺӽڵ㣬
					{ asLeftChild = false; break; }
				else if (!p.hasLChild())//ҳɹҿΪӲ룬
					{ asLeftChild = true; break; }
				else if (!p.hasRChild())//ҳɹҿΪҺӲ룬
					{ asLeftChild = false; break; }
				else//
					p = (BSTreeNode)p.getLChild();//мңȻвɣ
			}//ˣ½ڵΪpĺӲ룬ķchildTypeȷ
			lastV = new BSTreeNode(e, p, asLeftChild, null, null);//½ڵ
		}//else

		return e;
	}

//ʵдkeyΪؼĿժһڵ㣬дŵĿ򣬷null
//lastVָʾɾڵĸ
	public Entry remove(Object key) {
		if (isEmpty())	return null;//

		BinTreePosition v = binSearch((BSTreeNode)root, key, C);//
		if (0 != C.compare(key, ((BSTreeNode)v).getKey()))	return null;//ʧܣ򷵻null

	//˲ұسɹvΪɾڵ
		if (v.hasLChild()) {//vǿգ
			BinTreePosition w = v.getPrev();//vҳֱǰw
			w.setElem(v.setElem(w.getElem()));//vuݶ
			v = w;//൱ɾw
		}
		//ˣvֻһ
		//棬ɾv֮亢
		lastV = v.getParent();//ȡɾڵvĸ
		BinTreePosition u = v.hasLChild() ? v.getLChild() : v.getRChild();//ȡvĺu
		if (null == lastV)//vǡΪ
			{	if (null != u) u.secede();	root = u; }//uΪ
		else {//
			if (v.isLChild())//vpӣ
				{ v.secede();	lastV.attachL(u); }//ժvuΪp
			else//
				{ v.secede();	lastV.attachR(u); }//ժvuΪpҺ
		}
		return (Entry) v.getElem();//رɾڵдŵĵԪ
	}

//شʵĿһ
	public Iterator entries() {
		List list = new List_DLNode();
		concatenate(list, (BSTreeNode)root);
		return list.elements();
	}

/****************************  ****************************/
//vΪвҹؼΪkeyĽڵ㣨Ϊգ
//  ҵ򷵻ظýڵ
//  򣬷رʵһڵ
//ΪȷǷɹϲ㷽ҪټһηؽڵĹؼ
	protected static BSTreeNode binSearch(BSTreeNode v, Object key, Comparator c) {
		BSTreeNode	u = v;//ǰڵ
		while (true) {//ϵ
			int comp = c.compare(key, u.getKey());//ǰڵĿؼȽ
			if (comp < 0)//ĿؼС
				if (u.hasLChild())//u
					u = (BSTreeNode)u.getLChild();//ݹ
				else
					return u;//ֹӽڵ
			else if (comp > 0)//Ŀؼ
				if (u.hasRChild())//uҺ
					u = (BSTreeNode)u.getRChild();//ݹ
				else
					return u;//ֹҺӽڵ
			else
				return u;//
		}
	}

//vΪڵģӣУݹҳؼΪkeyнڵ
//Щڵ㱻֯Ϊһб˿һ
	protected static void finAllNodes(BSTreeNode v, Object k, List s, Comparator c) {
		if (null == v)	return;//ݹ
		int comp = c.compare(k, v.getKey());
		if (0 >= comp)	finAllNodes((BSTreeNode)v.getLChild(), k, s, c);//
		if (0 == comp)	s.insertLast(v);//
		if (0 <= comp)	finAllNodes((BSTreeNode)v.getRChild(), k, s, c);//
	}

//vкڵ㣨дŵĿ֯Ϊһб˿һ
	protected static void concatenate(List list, BSTreeNode v) {
		if (null == v)	return;
		concatenate(list, (BSTreeNode) v.getLChild());
		list.insertLast(v.getElem());
		concatenate(list, (BSTreeNode) v.getRChild());
	}
}