/**
 * бʵֵ
 */

package dsa;

public class IteratorTree implements Iterator {
	private List list;//б
	private Position nextPosition;//ǰһԪصλ

//ĬϹ췽
	public IteratorTree() { list = null; }

//ǰ
	public void elementsPreorderIterator(TreeLinkedList T) {
		if (null == T)	return;//ݹ
		list.insertLast(T);//ǰڵ
		TreeLinkedList	subtree = T.getFirstChild();//ӵǰڵĳӿʼ
		while (null != subtree) {//ζԵǰڵĸ
			this.elementsPreorderIterator(subtree);//ǰ
			subtree = subtree.getNextSibling();
		}
	}

//
	public void elementsPostorderIterator(TreeLinkedList T) {
		if (null == T)	return;//ݹ
		TreeLinkedList	subtree = T.getFirstChild();//ӵǰڵĳӿʼ
		while (null != subtree) {//ζԵǰڵĸ
			this.elementsPostorderIterator(subtree);//
			subtree = subtree.getNextSibling();
		}
		list.insertLast(T);//кʹŷʵǰڵ
	}

//α
	public void levelTraversalIterator(TreeLinkedList T) {
		if (null == T)	return;
		Queue_List	Q = new Queue_List();//ն
		Q.enqueue(T);//ڵ
		while (!Q.isEmpty()) {//ڶ±֮ǰ
			TreeLinkedList	tree = (TreeLinkedList) (Q.dequeue());//ȡ׽ڵ
			list.insertLast(tree);//³ӵĽڵ
			TreeLinkedList	subtree = tree.getFirstChild();//treeĵһ
			while (null != subtree) {//ҳкӣ
				Q.enqueue(subtree);//
				subtree = subtree.getNextSibling();
			}
		}
	}

//ǷʣԪ
	public boolean hasNext() { return (null != nextPosition); }

//صеһԪ
	public Object getNext() throws ExceptionNoSuchElement {
		if (!hasNext()) throw new ExceptionNoSuchElement("No next position");
		Position currentPosition = nextPosition;
		if (currentPosition == list.last())//ѵβԪأ
			nextPosition = null;//һԪ
		else//
			nextPosition = list.getNext(currentPosition);//תһԪ
		return currentPosition.getElem();
	}
}