/*
 * ˫ʵбṹ
 */

package dsa;

public class List_DLNode implements List {
	protected int numElem;//бʵʹģ
	protected DLNode header, trailer;//ڱ׽ڵ+ĩڵ

//캯
	public List_DLNode() {
		numElem = 0;//ձ
		header = new DLNode(null, null, null);//ͷڵ
		trailer = new DLNode(null, header, null);//βڵ
		header.setNext(trailer);//ͷβڵ໥
	}

/****************************  ****************************/
//λбǷϷǣתΪ*DLNode
	protected DLNode checkPosition(Position p) throws ExceptionPositionInvalid {
		if (null == p)
			throw new ExceptionPositionInvalid("⣺ݸList_DLNodeλnull");
		if (header == p)
			throw new ExceptionPositionInvalid("⣺ͷڵڱλ÷Ƿ");
		if (trailer == p)
			throw new ExceptionPositionInvalid("⣺βڱλ÷Ƿ");
		DLNode temp = (DLNode)p;
		return temp;
	}

/**************************** ADT ****************************/
//ѯбǰĹģ
	public int getSize() { return numElem; }
	
//жбǷΪ
	public boolean isEmpty() { return (numElem == 0); }

//صһԪأλã
	public Position first()	throws ExceptionListEmpty {
		if (isEmpty())
			throw new ExceptionListEmpty("⣺б");
		return header.getNext();
	}
	
//һԪأλã
	public Position last()	throws ExceptionListEmpty {
		if (isEmpty())
			throw new ExceptionListEmpty("⣺б");
		return trailer.getPrev();
	}

//ؽλ֮ǰԪأλã
	public Position getPrev(Position p) 
	throws ExceptionPositionInvalid, ExceptionBoundaryViolation {
		DLNode v = checkPosition(p);
		DLNode prev = v.getPrev();
		if (prev == header)
			throw new ExceptionBoundaryViolation("⣺ͼԽбǰ");
		return prev;
	}

//ؽӸλ֮Ԫأλã
	public Position getNext(Position p)
	throws ExceptionPositionInvalid, ExceptionBoundaryViolation {
		DLNode v = checkPosition(p);
		DLNode next = v.getNext();
		if (next == trailer)
			throw new ExceptionBoundaryViolation("⣺ͼԽб");
		return next;
	}

//eλ֮ǰλ
	public Position insertBefore(Position p, Object element)
	throws ExceptionPositionInvalid {
		DLNode v = checkPosition(p);
		numElem++;
		DLNode newNode = new DLNode(element, v.getPrev(), v);
		v.getPrev().setNext(newNode);
		v.setPrev(newNode);
		return newNode;
	}

//eӸλ֮λ
	public Position insertAfter(Position p, Object element)
	throws ExceptionPositionInvalid {
		DLNode v = checkPosition(p);
		numElem++;
		DLNode newNode = new DLNode(element, v, v.getNext());
		v.getNext().setPrev(newNode);
		v.setNext(newNode);
		return newNode;
	}
	
//eΪһԪزб
	public Position insertFirst(Object e) {
		numElem++;
		DLNode newNode = new DLNode(e, header, header.getNext());
		header.getNext().setPrev(newNode);
		header.setNext(newNode);
		return newNode;
	}

//eΪһԪزб
	public Position insertLast(Object e) {
		numElem++;
		DLNode newNode = new DLNode(e, trailer.getPrev(), trailer);
		if (null == trailer.getPrev())	System.out.println("!!!Prev of trailer is NULL!!!");
		trailer.getPrev().setNext(newNode);
		trailer.setPrev(newNode);
		return newNode;
	}

//ɾλôԪأ֮
	public Object remove(Position p)
	throws ExceptionPositionInvalid {
		DLNode v = checkPosition(p);
		numElem--;
		DLNode vPrev = v.getPrev();
		DLNode vNext = v.getNext();
		vPrev.setNext(vNext);
		vNext.setPrev(vPrev);
		Object vElem = v.getElem();
	//λãڵ㣩бժԱϵͳռõĿռ
		v.setNext(null);
		v.setPrev(null);
		return vElem;
	}

//ɾԪأ֮
	public Object removeFirst()
	{	return remove(header.getNext()); }

//ɾĩԪأ֮
	public Object removeLast()
	{	return remove(trailer.getPrev()); }

//ڸλõԪ滻ΪԪأر滻Ԫ
	public Object replace(Position p, Object obj)
	throws ExceptionPositionInvalid {
		DLNode v = checkPosition(p);
		Object oldElem = v.getElem();
		v.setElem(obj);
		return oldElem;
	}

//λõ
	public Iterator positions()
	{ return new IteratorPosition(this); }

//Ԫص
	public Iterator elements()
	{ return new IteratorElement(this); }
}
