/*
 * öʵȶ
 */

package dsa;

public class PQueue_Heap implements PQueue {
	private ComplBinTree H;//ȫʽĶ
	private Comparator comp;//Ƚ

//췽
	public PQueue_Heap()
	{ this(new ComparatorDefault(), null); }

//췽ĬϵĿȶ
	public PQueue_Heap(Comparator c)
	{ this(c, null); }

//췽ĳһֱʽ㷨SԪض(key, value)Ŀ
	public PQueue_Heap(Sequence S)
	{ this(new ComparatorDefault(), S); }

//췽ĳһֱʽ㷨sԪض(key, value)Ŀ
	public PQueue_Heap(Comparator c, Sequence s) {
		comp = c;
		H = new ComplBinTree_Vector(s);
		if (!H.isEmpty()) {
			for (int i = H.getSize()/2-1; i >= 0; i--)//Ե׶
				percolateDown(H.posOfNode(i));//ڵ
		}
	}

/*-------- PQueueӿжķ --------*/
//ͳȶеĹģ
	public int getSize()
	{ return H.getSize(); }

//жȶǷΪ
	public boolean isEmpty()
	{ return H.isEmpty(); }

//Qǿգ򷵻еСĿɾ;򣬱
	public Entry getMin() throws ExceptionPQueueEmpty {
		if (isEmpty())	throw new ExceptionPQueueEmpty("⣺ȶΪ");
		return (Entry) H.getRoot().getElem();
	}

//objؼkϳһĿQУظĿ
	public Entry insert(Object key, Object obj) throws ExceptionKeyInvalid	{
		checkKey(key);
		Entry entry = new EntryDefault(key, obj);
		percolateUp(H.addLast(entry));
		return entry;
	}

//QǿգժؼСĿظĿ򣬱
	public Entry delMin() throws ExceptionPQueueEmpty	{
		if (isEmpty())	throw new ExceptionPQueueEmpty("⣺ȶΪ");
		Entry min = (Entry)H.getRoot().getElem();//Ѷ
		if (1 == getSize())//ֻʣһĿ
			H.delLast();//ֱժ֮
		else {//
			H.getRoot().setElem(((ComplBinTreeNode_Rank)H.delLast()).getElem());
				//ȡһĿֲѶ
			percolateDown(H.getRoot());
		}
		return min;//ԭѶ
	}

/*--------  --------*/
//ؼĿɱȽ
	protected void checkKey(Object key) throws ExceptionKeyInvalid {
		try {
			comp.compare(key, key);
		} catch (Exception e) {
			throw new ExceptionKeyInvalid("޷ȽϹؼ");
		}
	}

//ؽڵvĿĹؼ
	protected Object key(BinTreePosition v) {
		return ((Entry)(v.getElem())).getKey();
	}

/*-------- 㷨 --------*/
//ӽڵ㣨ŵݣ
	protected void swapParentChild(BinTreePosition u, BinTreePosition v) {
		Object temp = u.getElem();
		u.setElem(v.getElem());
		v.setElem(temp);
	}

//㷨
	protected void percolateUp(BinTreePosition v) {
		BinTreePosition root = H.getRoot();//¼ڵ
		while (v != H.getRoot()) {//ϵ
			BinTreePosition p = v.getParent();//ȡǰڵĸ
			if (0 >= comp.compare(key(p), key(v)))	break;//ǸױȺС
			swapParentChild(p, v);//򣬽Ӵ
			v = p;//µĸڵ㣨ԭȵĺӣ
		}
	}

//㷨
	protected void percolateDown(BinTreePosition v) {
		while (v.hasLChild()) {//ֱvΪҶ
			BinTreePosition smallerChild = v.getLChild();//ȼӵģؼ룩С
			if (v.hasRChild() && 0 < comp.compare(key(v.getLChild()), key(v.getRChild())))
				smallerChild = v.getRChild();//ҺӴҸСҺΪһȽϵĶ
			if (0 <= comp.compare(key(smallerChild), key(v))) break;//ӶvС
			swapParentChild(v, smallerChild);//򣬽Сĺӽ
			v = smallerChild;//
		}
	}
}