/*
 * ˫ʵ
 */

package dsa;

public class Sequence_DLNode extends List_DLNode implements Sequence {
//rǷ[0, n)֮
	protected void checkRank(int r, int n)
	throws ExceptionBoundaryViolation {
		if (r < 0 || r >= n)
			throw new ExceptionBoundaryViolation("⣺Ƿ" + r + "Ӧ[0, " + n +")");
	}

//0 <= r < getSize()򷵻ΪrԪڵλã򣬱--O(n)
	public Position rank2Pos(int r) throws ExceptionBoundaryViolation {
		DLNode node;
		checkRank(r, getSize());
		if (r <= getSize()/2) {//ȽС
			node = header.getNext( );//ǰ˿ʼ
			for (int i=0; i<r; i++)	node = node.getNext();//һɨ
		} else {//Ƚϴ
			node = trailer.getPrev();//Ӻ˿ʼ
			for (int i=1; i<getSize()-r; i++)	node = node.getPrev();//һɨ
		}
		return node;
	}
	
//pеĺϷλã򷵻شpԪصȣ򣬱--O(n)
	public int pos2Rank(Position p) throws ExceptionPositionInvalid {
		DLNode	node = header.getNext();
		int		r = 0;
		while (node != trailer) {
			if (node == p)	return(r);
			node = node.getNext();	r++;
		}
		throw new ExceptionPositionInvalid("⣺Ϊλò");
	}

//ȡΪrԪ--O(n)
	public Object getAtRank(int r) throws ExceptionBoundaryViolation {
		checkRank(r, getSize());
		return rank2Pos(r).getElem();
	}

//ΪrԪ滻Ϊobj--O(n)
	public Object replaceAtRank(int r, Object obj) throws ExceptionBoundaryViolation {
		checkRank(r, getSize());
		return replace(rank2Pos(r), obj);
	}

//objΪΪrԪ--O(n)ظԪ
	public Object insertAtRank(int r, Object obj)	throws ExceptionBoundaryViolation {
		checkRank(r, getSize()+1);
		if (getSize() == r)	insertLast(obj);
		else								insertBefore(rank2Pos(r), obj);
		return obj;
	}

//ɾΪrԪ--O(n)
	public Object removeAtRank(int r) throws ExceptionBoundaryViolation {
		checkRank(r, getSize());
		return remove(rank2Pos(r));
	}
}